# cache2k 1.0.2.Final

## New and Noteworthy

- JCache: Update to the JCache spec and TCK 1.1, details below

## Fixes and Improvements

- Logging, Bugfix: Don't fallback to another logging facade if SLF4J nop logger is present, fixes: https://github.com/cache2k/cache2k/issues/77
- JCache 1.1: remove event has value and oldValue as remove value
- JCache 1.1: the statistics retrievable via JMX may have a short lag. 
  Extra code was removed for instant counter updates since this can be CPU intensive. 
- JCache 1.0/1.1: support for clearing statistics via JMX
- JCache 1.0/1.1: propagate exceptions for `loadAll()` via `CompletionListener.onException()`, tests for this were corrected in the TCK 
- JCache 1.0/1.1: support for `Closeable` on customizations, https://github.com/jsr107/jsr107tck/issues/100
- JCache 1.1: Remove special processing rule for `EntryProcessorException`, https://github.com/jsr107/jsr107tck/issues/85

## Using this cache2k version

### For Java SE/EE environments

````
    <dependency>
      <groupId>org.cache2k</groupId>
      <artifactId>cache2k-api</artifactId>
      <version>1.0.2.Final</version>
      <scope>provided</scope>
    </dependency>
    <dependency>
      <groupId>org.cache2k</groupId>
      <artifactId>cache2k-all</artifactId>
      <version>1.0.2.Final</version>
      <scope>runtime</scope>
    </dependency>
````

### For Android

````
    <dependency>
      <groupId>org.cache2k</groupId>
      <artifactId>cache2k-api</artifactId>
      <version>1.0.2.Final</version>
    </dependency>
    <dependency>
      <groupId>org.cache2k</groupId>
      <artifactId>cache2k-core</artifactId>
      <version>1.0.2.Final</version>
      <scope>runtime</scope>
    </dependency>
````

### Using the JCache / JSR107 provider

````
    <dependency>
      <groupId>org.cache2k</groupId>
      <artifactId>cache2k-jcache</artifactId>
      <version>1.0.2.Final</version>
    </dependency>
    <dependency>
      <groupId>javax.cache</groupId>
      <artifactId>cache-api</artifactId>
      <version>1.1.0</version>
    </dependency>
````
